#ifndef _paintown_message_queue_h
#define _paintown_message_queue_h

#include <queue>
#include <pthread.h>
#include <string>

/* multithreaded message queue.
 * someone puts messages in, someone takes them out.
 * FIFO order
 */
class MessageQueue{
public:
    MessageQueue();

    /* push on */
    void add(const std::string & str);
    /* true if any messages are left */
    bool hasAny();
    /* get the first message */
    std::string get();

    ~MessageQueue();
private:
    std::queue<std::string> messages;
    pthread_mutex_t lock;
};

#endif
